##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import zLOG
import Globals
import string
from Globals import PersistentMapping
from Persistence import Persistent
from DateTime import DateTime

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowMethod
from Products.CMFCore.utils import getToolByName
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

from AccessControl import ClassSecurityInfo

from General import audioformats, videoqualities, audienceratings, bandwidths
from ServerLogic import ServerLogic

factory_type_information = ({
       'id': 'Live Server',
       'meta_type': 'Media Manager Live Server Logic',
       'description': 'Use live server logic to describe your live servers',
       'product': 'MyMediaManager',
       'icon': 'file_icon.gif',
       'factory': 'addLiveServerLogic',
       'filter_content_types': 0,
       'immediate_view': 'liveserverlogic_edit_form',
       'actions':
               (
                {
                 'name': 'View',
                 'action': 'liveserverlogic_view',
                 'permissions': ('View',),
                 'category': 'object'},
                {
                 'name': 'Edit',
                 'action': 'liveserverlogic_edit_form',
                 'permissions': ('Manage properties',),
                 'category':'object'})
                },)

class LiveServerLogic (ServerLogic):
    meta_type = 'Media Manager Live Server Logic'

    inputPort = 4040
    inputPath = '/'
    bandwidth = 'singleisdn'
    xsize = '240'
    ysize = '180'
    audioformat = 'background'
    video_quality = 'smooth'
    audience_rate = 'general'
    transport = 'tcp'

    audioformats = audioformats
    videoqualities = videoqualities
    audienceratings = audienceratings
    bandwidths = bandwidths

    def __init__(self, id, title='', description=''):
        DefaultDublinCoreImpl.__init__(self)
        self.id = id
        self.title = title
        self.description = description
        self.protocol = ''
        self.host = ''
        self.outputPort = 554
        self.outputDir = '/'
        self.extension = ''
        self.ppv_serverid = 'MMManager'
        self.ftp_username = ''
        self.ftp_password = ''
        self.ftp_dir = ''
        self.servertype = ''
        self.inputPort = 4040
        self.inputDir = '/'
        self.bandwidth = 'singleisdn'
        self.xsize = '240'
        self.ysize = '180'
        self.audioformat = 'background'
        self.video_quality = 'smooth'
        self.audience_rate = 'general'
        self.transport = 'tcp'

    def editLive(self, inputPort=None, inputDir=None, bandwidth=None, xsize=None, ysize=None, audioformat=None, video_quality=None, audience_rate=None, transport=None):
        if inputPort is not None:
            inputPort = string.replace(inputPort, ':', '')
            if len(inputPort) > 0:
                try:
                    inputPort = int(inputPort)
                except:
                    raise 'Attribute Error', 'Port number must be an integer'
            self.inputPort = inputPort
            
        if inputDir is not None:
            self.inputDir = inputDir
        if bandwidth is not None:
            self.bandwidth = bandwidth
        if xsize is not None:
            self.xsize = xsize
        if ysize is not None:
            self.ysize = ysize
        if audioformat is not None:
            self.audioformat = audioformat
        if video_quality is not None:
            self.video_quality = video_quality
        if audience_rate is not None:
            self.audience_rate = audience_rate
        if transport is not None:
            self.transport = transport

def addLiveServerLogic(self, id, title='', REQUEST=None):
    ob = LiveServerLogic(id, title)
    self._setObject(id, ob)
    logic = self._getOb(id)
    mm = getToolByName(logic, 'portal_mediamanager')
    path = getToolByName(logic, 'portal_url').getRelativeContentURL(logic)
    medianet = mm.getMedianetFor(self)
    medianet.addLiveLogic(path)


Globals.InitializeClass(LiveServerLogic)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(LiveServerLogic,
                      constructors=(addLiveServerLogic,),
		      action='liveserverlogic_edit_form',
		      icon='file_icon.gif')
