##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import zLOG
import Globals
import string
from Globals import PersistentMapping
from Persistence import Persistent
from DateTime import DateTime

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowMethod
from Products.CMFCore.utils import getToolByName
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

from AccessControl import ClassSecurityInfo

from General import audioformats, videoqualities, audienceratings, bandwidths


factory_type_information = ({
      'id': 'OnDemand Server',
      'meta_type': 'Media Manager Server Logic',
      'description': 'Use server logic to describe your ondemand servers',
      'product': 'MyMediaManager',
      'icon': 'file_icon.gif',
      'factory': 'addServerLogic',
      'filter_content_types': 0,
      'immediate_view': 'serverlogic_edit_form',
      'actions':
	      ({'name': 'View',
	        'action': 'serverlogic_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'serverlogic_edit_form',
		'permissions': ('Modify portal content',)})
       },)

class ServerLogic( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Link
    """

    meta_type='Media Manager Server Logic'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1
    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id = id
        self.title = title
        self.description = description
        self.protocol = ''
        self.host = ''
        self.outputPort = '554'
        self.outputDir = '/'
        self.extension = ''
        self.ppv_serverid = 'MMManager'
        self.servertype = ''
        self.ftp_username = ''
        self.ftp_password = ''
        self.ftp_dir = ''
        self.use_membercontentdir = 0
	
    security.declareProtected(ManageProperties, 'edit')
    def edit (self, title=None, servertype=None, protocol=None, host=None, outputPort=None, extension=None, outputDir=None, PPV_ServerID=None, ftp_username=None, ftp_password=None, ftp_dir=None, use_membercontentdir=None):
    	if title is not None:
            self.setTitle(title)

    	if servertype is not None:
            self.servertype = servertype

    	if protocol is not None:
            self.protocol = protocol

    	if host is not None:
            self.host = host

    	if outputPort is not None:
    	    outputPort = string.replace(outputPort, ':', '')
    	    if len(outputPort) > 0:
    	        try:
    	            outputPort = int(outputPort)
    	        except:
    	            raise 'Attribute Error', 'Port number must be an integer'
            self.outputPort = outputPort

    	if extension is not None:
	       self.extension = extension

    	if outputDir is not None:
    	       if len(outputDir) > 0:
    	           if not outputDir[0] == '/':
    	               outputDir = '/%s' % outputDir
    	           if not outputDir[-1] == '/':
    	               outputDir = '%s/' % outputDir
    	           space_count = string.count(outputDir, ' ')
    	           if space_count > 0:
    	               raise 'Attribute Error', 'Spaces not allowed in path'
    	       else:
    	           outputDir = '/'
	       self.outputDir = outputDir

    	if PPV_ServerID is not None:
	       self.ppv_serverid = PPV_ServerID

    	if ftp_username is not None:
	       self.ftp_username = ftp_username

    	if ftp_password is not None:
	       self.ftp_password = ftp_password

    	if ftp_dir is not None:
	       self.ftp_dir = ftp_dir

        if use_membercontentdir is not None:
            self.use_membercontentdir = use_membercontentdir

    security.declarePublic('getPlayerUrl')
    def getPlayerUrl(self, usepath=1):
        url = '%s://%s' % (self.protocol, self.host)
        zLOG.LOG('Server logic', zLOG.INFO, 'output port: %s' % str(self.outputPort))
        if type(self.outputPort) == type(1):
            url = '%s:%d' % (url, self.outputPort)
        if usepath:
            url = '%s%s' % (url, self.outputDir)
        return url

    security.declarePublic('getFileExtension')
    def getFileExtension(self):
	    return self.extension

    security.declarePublic('getServerType')
    def getServerType(self):
    	mediaman = getToolByName(self, 'portal_mediamanager')
        for typeset in mediaman.getServerTypes():
            if typeset['id'] == self.servertype:
                return typeset['title']

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    def cb_isMoveable(self):
	    return 0

    def cb_isCopyable(self):
    	"""
	      You can copy this object
    	"""
        return 1

def addServerLogic(self, id, title='', REQUEST=None):
    ob=ServerLogic(id,title)
    self._setObject(id, ob)
    logic = self._getOb(id)
    mm = getToolByName(logic, 'portal_mediamanager')
    medianet = mm.getMedianetFor(self)
    path = getToolByName(logic, 'portal_url').getRelativeContentURL(logic)
    medianet.addOndemandLogic(path)


Globals.InitializeClass(ServerLogic)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(ServerLogic,
                      constructors=(addServerLogic,),
                      action='serverlogic_edit_form',
                      icon='file_icon.gif')
