##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""Media Manager tool description.
$Id: MediaManagerTool.py,v 1.1.1.1 2002/02/12 12:09:58 thomas Exp $
"""
__version__='$Revision: 1.1.1.1 $'[11:-2]

from Interface import Attribute, Base

class MediaManagerTool( Base ):
    '''
    Common tool for getting info about Media Manager objects.
    This tool allowes programmers to have easy access to the various
    object types in a Media Manager CMF installation. It provides
    an API that should be stable.
    '''

    # trut
    def getSmilObjectFor(self, content):
        """
            Return the SMIL object for content, creating it in the folder of the event in context if need be.
        """

    def getEventFor(self, content, path = None):
        """
            Return the event object for content, can be itself.
            The returned event is not necessarily the event in
            which the object is contained but the event in
            which the object is shown.
            The path is the url of the topmost frame ('/Members/foobar/MyClip') - if it is 'None'
            the returned value is either the event in which the
            object is contained or 'None'.
        """

    def isMediaManagerType( self, content ):
        '''
            Returns a boolean indicating whether content is of a type this tool handles.
        '''

    def listActions(self, info):
        """
        Return actions for reply and show replies. Used by 'portal_actions'.
        """

    def _createSmilObjectFor( self, content ):
        """
            Internal. Create a SMIL object in the event that content is in context off.
        """


