from string import lstrip
import zLOG

class FakeGettextExpr:
    def __init__(self, name, expr, compiler):
        self._s = expr = lstrip(expr)
        self._c = compiler.compile(expr)

    def __call__(self, econtext):
        return self._c(econtext)

    def __repr__(self):
        return 'gettext:%s' % `self._s`


def fake_localization():
    """
    Create a fake 'gettext' expression for zpt
    """
    from Products.PageTemplates import Expressions
    engine = Expressions.getEngine()
    if not engine.getTypes().has_key('gettext'):
        engine.registerType('gettext', FakeGettextExpr)


def initialize():
    """
    Initialize localisation if Localizer and CMFLocalizer is installed
    """
    try:
        from Products.Localizer import Locale
        try:
            from Products.CMFLocalizer import GettextExpr
            zLOG.LOG('i18n',zLOG.INFO, 'Using CMFLocalizer')
        except:
            fake_localization()
            zLOG.LOG('i18n',zLOG.INFO, 'Using fake Localizer')
    except:
        fake_localization()
